solve(Sol) :- template(Template), fill(Template), reverse(Template, Sol).

fill(S) :- initial_state(S).
fill([Next,S|States]) :- fill([S|States]), arc(S, Next), \+member(Next, States).

%% am abstractizat (vor trebui specificate pentru fiecare problemă particulară)
%%		- initial_state
%%		- template (pe post de stare finală)
%%		- arc
initial_state([(1,1)]).
n(5).
template(T) :- n(N), N2 is N * N, length(T, N2).
arc(S, Next) :- n(N), arc(N, S, Next).

%% pt săritura calului
%% 	- stare = poziție în template
arc(N, (X1,Y1), (X2,Y2)) :-
	member((Dx,Dy), [(-2,-1), (-2,1), (-1,-2), (-1,2), (1,-2), (1,2), (2,-1), (2,1)]),
	X2 is X1 + Dx, X2 > 0, X2 =< N,
	Y2 is Y1 + Dy, Y2 > 0, Y2 =< N.
	
count_sol(C) :- findall(_, solve(_), R), length(R, C).



	
